import { Component, Inject, ElementRef, EventEmitter, HostListener, Injectable } from '@angular/core';
import { Http, Response } from '@angular/http';
import 'rxjs/add/operator/map';

declare var jQuery: any;


@Injectable()
export class MyService {
    constructor(private http: Http) { }

    getAll() {
        let people$ = this.http
            .get("app/products.json").map((res: Response) => res.json());
        return people$;
    }
}

@Component({
    selector: 'my-app',
    template: `
        <ig-grid [(options)]="gridOptions" [(widgetId)]='id'></ig-grid>
        `,
    providers: [MyService]
})
export class AppComponent {
    private gridOptions: IgGrid;
    private id: string;

    constructor(private myService: MyService) {
        this.myService.getAll().subscribe(
            res => {
                //this.gridOptions.dataSource = res.slice(0, 5);
                jQuery('#' + this.id).igGrid("option", "dataSource", res.slice(0, 5));
            }
        );

        this.id = 'grid1';

        this.gridOptions = {
            autoCommit: true,
            dataSource: [],
            width: "900px",
            height: "400px",
            autoGenerateColumns: false,
            primaryKey: "ProductID",
            columns: [
                { key: "ProductID", headerText: "Product ID", width: "100px", dataType: "number" },
                { key: "ProductName", headerText: "Name", width: "250px", dataType: "string" },
                { key: "DealerName", headerText: "Dealer Name", width: "100px", dataType: "string" },
                { key: "CategoryName", headerText: "CategoryName", width: "250px", dataType: "string" },
                { key: "InStock", headerText: "InStock", width: "100px", dataType: "number" },
                { key: "Inventory", headerText: "Inventory", width: "100px", dataType: "null" }
            ],
            features: [
            {
                name: 'Paging',
                type: 'remote',
                pageSize: 5,
                pagerRendering: (e, ui) => {
                    ui.dataSource.totalRecordsCount(30);
                }
            }]
        }
    }
}